



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Jsonp简单认识(后端使用的是asp.net mvc)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Jsonp简单认识(后端使用的是asp.net mvc)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 23:24:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一、Jsonp简介：由于浏览器基于安全有同源策略(同源策略阻止从一个源加载的文档或脚本获取或设置另一个源加载的文档的属性)机制，所以前端无法使用Ajax来获取来获取其他域名下返回的数据，而Jsonp可以实现跨域访问。</p>
<p>　　Jsonp是基于&lt;script&gt;标签不受同源策略限制，可以加载任意地方的JavaScript文件来实现的。Jsonp实现理念就是，和服务端约定好一个函数名，当请求文件时，服务端返回一段JavaScript。这段JavaScript调用了约定好的函数，并且将数据当做参数传入。</p>
<p>二、简单Demo</p>
<p>1、在visual studio新建项目JsonpDemo和项目OtherDomain，项目结构如下</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/705942/201510/705942-20151027145212185-2108761681.png" /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/705942/201510/705942-20151027145336404-861919686.png" /></p>
<p>2、在JsonpDemo项目中新增HomeController及其视图，视图中代码如下：</p>
<div>
<div>
<pre class="prettyprint linenums"> @{<br />
     Layout = null;<br />
 }

 &lt;!DOCTYPE html&gt;

 &lt;html&gt;<br />
 &lt;head&gt;<br />
     &lt;meta name="viewport" content="width=device-width" /&gt;<br />
     &lt;title&gt;Index&lt;/title&gt;<br />
 &lt;/head&gt;<br />
 &lt;body&gt;<br />
     &lt;div&gt;<br />
         &lt;input type="button" id="getJsonpByHand" value="get jsonp by hand" /&gt;<br />
     &lt;/div&gt;<br />
     &lt;script type="text/javascript" &gt;<br />
         $("#getJsonpByHand").click(function () {<br />
 　　　　　　　//55157位OtherDomain项目启动后网站的端口<br />
             CreateScript("http://localhost:55157/home/somejsonp?");<br />
         })<br />
         function CreateScript(src) {<br />
             $("&lt;script&gt;&lt;//script&gt;").attr("src", src).appendTo("body")<br />
         }<br />
 　　　　　//myCallBack就是与后端约定好的函数<br />
         function myCallBack(data) {<br />
             console.log(data);<br />
         }<br />
     &lt;/script&gt;<br />
 &lt;/body&gt;<br />
 &lt;/html&gt;</pre>
</div>
</div>
<p>3、在OtherDomain项目中新增HomeController及其视图，HomeController中代码如下：</p>
<div>
<div>
<pre class="prettyprint linenums">using Newtonsoft.Json;<br />
using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Web;<br />
using System.Web.Mvc;

namespace OtherDomain.Controllers<br />
{<br />
    public class HomeController : Controller<br />
    {<br />
        //<br />
        // GET: /Home/

        public ActionResult Index()<br />
        {<br />
            return View();<br />
        }

        public ActionResult SomeJsonp()<br />
        {<br />
            return new ContentResult()<br />
            {<br />
                //myCallBack为服务端与前端约定好的函数<br />
                Content = "myCallBack(" + JsonConvert.SerializeObject(new { Name = "Tom", Age =  }) + ")",<br />
                ContentType = "text/html"<br />
            };<br />
        }

    }<br />
}</pre>
</div>
</div>
<p>4、启动两个项目，点击JsonpDemo项目页面中的按钮，谷歌浏览器控制台下看到</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/705942/201510/705942-20151027151335247-1084183608.png" /></p>
<p>三、对上面Demo做一下简单优化，可以通过前端来指定与服务器约定的函数</p>
<p>1、修改JsonpDemo项目index.cshtml页面中，按钮点击事件下CreateScript方法传入参数为：http://localhost:55157/home/somejsonp?callback=myCallBack 也就是加上一个URL参数</p>
<p>2、修改OtherDomain项目下HomeController.cs中SomeJsonp方法如下：</p>
<div>
<pre class="prettyprint linenums">        public ActionResult SomeJsonp()<br />
        {<br />
            string func = Request.Params["callback"];<br />
            return new ContentResult()<br />
            {<br />
                Content = func+"(" + JsonConvert.SerializeObject(new { Name = "Tom", Age =  }) + ")",<br />
                ContentType = "text/html"<br />
            };<br />
        }</pre>
</div>
<p>四、通过jQuery使用Jsonp实现跨域请求</p>
<p>1、继续沿用上面两个项目，修改JsonpDemo项目index.cshtml页面代码，新增一个按钮，并实现其click事件相关代码，如下：</p>
<div>
<div>
<pre class="prettyprint linenums">@{<br />
    Layout = null;<br />
}

&lt;!DOCTYPE html&gt;

&lt;html&gt;<br />
&lt;head&gt;<br />
    &lt;meta name="viewport" content="width=device-width" /&gt;<br />
    &lt;title&gt;Index&lt;/title&gt;<br />
    &lt;script src="~/Scripts/jquery-1.8.2.min.js"&gt;&lt;/script&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
    &lt;div&gt;<br />
        &lt;input type="button" id="getJsonpByHand" value="get jsonp by hand" /&gt;<br />
         &lt;input type="button" id="getJsonpByJquery" value="get jsonp by jquery" /&gt;<br />
    &lt;/div&gt;<br />
    &lt;script type="text/javascript" &gt;<br />
        $("#getJsonpByHand").click(function () {<br />
            CreateScript("http://localhost:55157/home/somejsonp?callback=myCallBack");<br />
        })<br />
        function CreateScript(src) {<br />
            $("&lt;script&gt;&lt;//script&gt;").attr("src", src).appendTo("body")<br />
        }<br />
        $("#getJsonpByJquery").click(function () {<br />
            $.ajax({<br />
                // url: 'http://localhost:55157/home/somejsonp?callback=myCallBack',<br />
                url: 'http://localhost:55157/home/somejsonp',<br />
                dataType: "jsonp",<br />
                jsonp: "callback",<br />
                success: function (data) {<br />
                    console.log(data)<br />
                    var a=123;<br />
                    var b=2;<br />
                    var c=35;<br />
                }<br />
            })<br />
        })<br />
        //function myCallBack(data) {<br />
        //    console.log(data);<br />
        //}<br />
    &lt;/script&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
</div>
<p>注意上面ajax参数dataType为jsonp，jsonp为callback</p>
<p>2、OtherDomain下HomeController.cs文件SomeJsonp代码和第三个里面代码一样，如下：</p>
<div>
<div>
<pre class="prettyprint linenums">  public ActionResult SomeJsonp()<br />
        {<br />
            string func = Request.Params["callback"];<br />
            return new ContentResult()<br />
            {<br />
                Content = func + "(" + JsonConvert.SerializeObject(new { Name = "Tom", Age =  }) + ")",<br />
                ContentType = "text/html"<br />
            };<br />
        }</pre>
</div>
</div>
<p>3、运行两个项目，点击&ldquo;get jsonp by jquery&rdquo;按钮，可以在谷歌浏览器控制台下看到同样结果</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/705942/201510/705942-20151027160006154-1992984663.png" /></p>
<p>4、注意：如果前端代码传入callback参数，那么前端也要自己实现相应参数的函数。如果没有传入，其实jQuery自己会默认传入并自己实现。</p>
<p>五、扩展：在OtherDomain项目下，简单自定义JsonpResult类，代码如下：</p>
<div>
<div>
<pre class="prettyprint linenums"> using System;<br />
 using System.Collections.Generic;<br />
 using System.Linq;<br />
 using System.Web;<br />
 using System.Web.Mvc;

 namespace OtherDomain<br />
 {<br />
     public class JsonpResult : JsonResult<br />
     {<br />
         private const string CALLBACK_QUERYSTRING = "callback";<br />
         //private const string CALLBACK_CONTENTTYPE = "application/x-javascript";<br />
         private const string CALLBACK_CONTENTTYPE = "text/javascript";

         public override void ExecuteResult(ControllerContext controllerContext)<br />
         {<br />
             if (controllerContext != null)<br />
             {<br />
                 var request = controllerContext.HttpContext.Request;<br />
                 object callback = request[CALLBACK_QUERYSTRING];<br />
                 if (callback == null)<br />
                 {<br />
                     controllerContext.RouteData.Values.TryGetValue(CALLBACK_QUERYSTRING, out callback);<br />
                 }

                 var hasCallback = !string.IsNullOrWhiteSpace(callback == null ? "" : callback as string);<br />
                 if (hasCallback)<br />
                 {<br />
                     SetContentTypeIfEmpty();<br />
                     var response = controllerContext.HttpContext.Response;<br />
                     response.Write(callback);<br />
                     response.Write("(");<br />
                     base.ExecuteResult(controllerContext);<br />
                     response.Write(")");<br />
                 }<br />
                 else<br />
                 {<br />
                     base.ExecuteResult(controllerContext);<br />
                 }<br />
             }<br />
         }

         private void SetContentTypeIfEmpty()<br />
         {<br />
             if (string.IsNullOrWhiteSpace(base.ContentType))<br />
             {<br />
                 base.ContentType = CALLBACK_CONTENTTYPE;<br />
             }<br />
         }<br />
     }

     public static class ContollerExtensions<br />
     {<br />
         public static JsonpResult Jsonp(this Controller controller, object data, JsonRequestBehavior behavior = JsonRequestBehavior.DenyGet)<br />
         {<br />
             JsonpResult result = new JsonpResult();<br />
             result.Data = data;<br />
             result.JsonRequestBehavior = behavior;<br />
             return result;<br />
         }<br />
     }<br />
 }</pre>
</div>
<p>JsonpResult及ContollerExtensions</p></div>
<p>如果想要很好的结合到controller中，需要写如上ContollerExtensions的Controller的扩展方法</p>
<p>在OtherDomain项目下，需要修改SomeJsonp方法：</p>
<div>
<pre class="prettyprint linenums">  　　  public ActionResult SomeJsonp()<br />
        {<br />
            return this.Jsonp(new<br />
            {<br />
                Name= "Tom",<br />
                Age=<br />
            }, JsonRequestBehavior.AllowGet);<br />
        }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4yxreq.html">iOS多线程-RunLoop简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/390r0l49.html">swift 中数据类型那个的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ege29.html">JSON&period;stringify语法解析（自己留存）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1wre38.html">SQL Insert语句数据以以unicode码存储 解决存储数据出现乱码的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y6605q.html">&num;&num;&num; MATLAB - CUDA</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znw329.html">Ubuntu15&period;10 编译VLC Android（安卓）过程记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1zkox8.html">cocos2d-x项目过程记录&lpar;cocos2d-x的新知&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v622m8.html">解决如何让AsyncTask终止操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpznvq.html">Qt creator 搭配 valgrind 检测内存泄漏</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm2p1l9.html">&lbrack;C&plus;&plus;程序设计&rsqb;指针数组和指向指针的指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp11g69.html">jquery 获取 TABLE单元格的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj55k5q.html">SQL Server-聚焦NOLOCK、UPDLOCK、HOLDLOCK、READPAST你弄懂多少？（三十四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meorgoq.html">msmq访问格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjep009.html">Mysql 创建用户授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14l7xq.html">LeetCode算法题-Path Sum（Java实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jnzknq.html">button 去掉原生边框</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwygmq.html">JAVA调用外部安装7-Zip压缩和解压zip文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwr7179.html">学生成绩管理系统（C&plus;&plus;指针、链表、文件及面向对象的运用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jwnxeq.html">Visual Studio2017 Remote Debugger</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxy4d9.html">jackson出现错误 Unrecognized field，几种处理方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qymvmjq.html">bootstrap和jquery mobile的对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8en0mm8.html">google的glog的用法：</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv6zkx8.html">C&num;&plus;OpenGL编程之再见小桃子&lpar;The Tao Framework&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qymrymq.html">&amp;amp&semi;10 基本数据结构&mdash;&mdash;栈，队列和链表</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv60dy8.html">codeskulptor hosts</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlg54k9.html">caffe windows学习：第一个测试程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93en0zq.html">Node&period;js文件系统、路径的操作函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96xyp39.html">关于多个EditText的OnTextChange事件陷入死循环的处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxp55z9.html">JQuery学习笔记&mdash;&mdash;JQuery基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4r7rj8.html">unity3d 扩展NGUI &mdash;&mdash; 限制UI点击响应间隔</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
